package im.zego.effects.sdkmanager.utils;

import android.content.Context;
import java.io.File;
import java.util.ArrayList;
import im.zego.effects.sdkmanager.EffectsSDKManager;

public class EffectsSDKHelp {

    public void init(Context context) {

        String path = context.getExternalCacheDir().getPath() + "/effects";
        //做版本判断，如果美颜美型资料变更要先删除了在copy
        if (EffectsSharedPreferencesUtil.getEffectVersion(context) != EffectsSDKManager.getInstance().getEffectVersion()) {
            File file = new File(path);
            FileUtil.deleteDir(file);
            file.mkdirs();
            EffectsSharedPreferencesUtil.setEffectVersion(context, EffectsSDKManager.getInstance().getEffectVersion());
        }

        ArrayList<String> aiModeInfoList = copyAiModeInfoList(context);
        ArrayList<String> resourcesInfoList = copyResourcesInfoList(context);

        EffectsSDKManager.getInstance().initEvn(context, aiModeInfoList, resourcesInfoList);

    }

    private ArrayList<String> copyAiModeInfoList(Context context) {
        String path = context.getExternalCacheDir().getPath() + "/effects";
        String faceDetection = "Models/FaceDetectionModel.bundle";
        String segmentation = "Models/SegmentationModel.bundle";
        FileUtil.copyFileFromAssets(context, faceDetection, path + File.separator + faceDetection);

        FileUtil.copyFileFromAssets(context, segmentation, path + File.separator + segmentation);
        ArrayList<String> aiModeInfoList = new ArrayList<>();
        aiModeInfoList.add(path + File.separator + faceDetection);
        aiModeInfoList.add(path + File.separator + segmentation);

        return aiModeInfoList;
    }

    private ArrayList<String> copyResourcesInfoList(Context context) {
        String path = context.getExternalCacheDir().getPath() + "/effects";
        String faceWhitening = "Resources/FaceWhiteningResources.bundle";
        String pendantResources = "Resources/PendantResources.bundle";
        String rosyResources = "Resources/RosyResources.bundle";
        String teethWhiteningResources = "Resources/TeethWhiteningResources.bundle";

        FileUtil.copyFileFromAssets(context, faceWhitening, path + File.separator + faceWhitening);
        FileUtil.copyFileFromAssets(context, pendantResources, path + File.separator + pendantResources);
        FileUtil.copyFileFromAssets(context, rosyResources, path + File.separator + rosyResources);
        FileUtil.copyFileFromAssets(context, teethWhiteningResources, path + File.separator + teethWhiteningResources);

        ArrayList<String> resourcesInfoList = new ArrayList<>();
        resourcesInfoList.add(path + File.separator + faceWhitening);
        resourcesInfoList.add(path + File.separator + pendantResources);
        resourcesInfoList.add(path + File.separator + rosyResources);
        resourcesInfoList.add(path + File.separator + teethWhiteningResources);

        return resourcesInfoList;
    }

}
