package im.zego.liveshow.effects.adapter;

import android.graphics.Color;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
import androidx.annotation.Nullable;
import com.chad.library.adapter.base.BaseViewHolder;
import java.util.List;
import im.zego.liveshow.R;

public class BackgroundSoundAdapter extends BaseSelectAdapter<String, BaseViewHolder> {

    public BackgroundSoundAdapter(@Nullable List<String> data) {
        super(R.layout.liveshow_background_sound_item, data);
        setCurrentType(SelectType.single);
    }

    @Override
    protected void selectConvert(boolean isSelect, BaseViewHolder helper, String item) {

        TextView soundName = helper.getView(R.id.tv_sound_type_name);
        ImageView soundImgUnSelect = helper.getView(R.id.iv_icon_unselect);
        ImageView soundImgSelect = helper.getView(R.id.iv_icon_select);

        soundName.setText(item);

        if (isSelect) {
            soundImgSelect.setVisibility(View.VISIBLE);
            soundImgUnSelect.setVisibility(View.INVISIBLE);
            soundName.setTextColor(Color.parseColor("#ffa653ff"));
        } else {
            soundImgSelect.setVisibility(View.INVISIBLE);
            soundImgUnSelect.setVisibility(View.VISIBLE);
            soundName.setTextColor(Color.parseColor("#ffffffff"));
        }
    }

}
