package im.zego.liveshow.effects.adapter;


import android.content.Context;
import android.graphics.Color;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.Nullable;

import com.chad.library.adapter.base.BaseViewHolder;

import java.util.List;

import im.zego.liveshow.R;
import im.zego.liveshow.model.ReverbPresetInfo;
import im.zego.liveshow.utils.GlideLoader;

public class ReverbPresetAdapter extends BaseSelectAdapter<ReverbPresetInfo, BaseViewHolder> {

    private Context mContext;

    public ReverbPresetAdapter(@Nullable List<ReverbPresetInfo> data,Context mContext) {
        super(R.layout.liveshow_reverbpreset_item, data);
        this.mContext = mContext;
        setCurrentType(SelectType.single);
    }

    @Override
    protected void selectConvert(boolean isSelect, BaseViewHolder helper, ReverbPresetInfo item) {
        TextView reverbPresetName = helper.getView(R.id.tv_rp_name);
        ImageView reverbPresetIcon = helper.getView(R.id.iv_rp_icon);

        reverbPresetName.setText(item.getRpName());
        if (isSelect) {
            GlideLoader.displayCircleImageByBorder(item.getRpIcon(),reverbPresetIcon,mContext);
            reverbPresetName.setTextColor(Color.parseColor("#ffa653ff"));
        } else {
            GlideLoader.displayCircleImage(item.getRpIcon(),reverbPresetIcon);
            reverbPresetName.setTextColor(Color.parseColor("#ffcccccc"));
        }

    }

}
