package im.zego.liveshow.liveroom.adapter;

import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;


import java.util.ArrayList;
import java.util.List;

import im.zego.liveshow.R;
import im.zego.liveshow.liveroom.LiveRoomView;
import im.zego.liveshow.manager.callbacks.IRoomManagerCallback;
import im.zego.liveshow.model.RoomListInfo;


public class LiveRoomAdapter extends RecyclerView.Adapter<LiveRoomAdapter.LiveRoomViewHolder>{

    private List<RoomListInfo.RoomListDTO> list = new ArrayList<RoomListInfo.RoomListDTO>();



    @NonNull
    @Override
    public LiveRoomViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        LiveRoomView view = new LiveRoomView(parent.getContext());
        FrameLayout.LayoutParams layoutParams = new
                FrameLayout.LayoutParams(FrameLayout.LayoutParams.MATCH_PARENT,FrameLayout.LayoutParams.MATCH_PARENT);
        view.setLayoutParams(layoutParams);
        return new LiveRoomViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull LiveRoomViewHolder holder, int position) {

    }

    @Override
    public int getItemCount() {
        return list.size();
    }

    public void addData(RoomListInfo.RoomListDTO roomInfo){
        list.add(roomInfo);
        notifyDataSetChanged();
    }

    public void refreshData(List<RoomListInfo.RoomListDTO> roomInfo){
        list = roomInfo;
        notifyDataSetChanged();
    }

    public List<RoomListInfo.RoomListDTO> getData(){
        return list;
    }
    public void playStream(View view,int position,boolean enable) {
        if(position >= 0 && position < list.size()) {

            RoomListInfo.RoomListDTO data = list.get(position);

            IRoomManagerCallback callback = (IRoomManagerCallback) view;
            if(callback != null){
                view.setTag(R.id.liveshow_live_room_data, data);
                callback.playStream(enable);

            }
        }

    }

    public void stopStream(View view,int position) {
        if(position >= 0 && position < list.size()) {

            IRoomManagerCallback callback = (IRoomManagerCallback) view;
            if(callback != null){
                callback.stopStream();

            }
        }

    }

    public void logoutRoom(View view,int position){
        if(position >= 0 && position < list.size()) {

            IRoomManagerCallback callback = (IRoomManagerCallback) view;
            if(callback != null){
                callback.logoutRoom();

            }
        }
    }

    public void loginRoom(View view,int position){

        if(position >= 0 && position < list.size()) {
            RoomListInfo.RoomListDTO data = list.get(position);
            IRoomManagerCallback callback = (IRoomManagerCallback) view;
            if(callback != null){
                view.setTag(R.id.liveshow_live_room_data, data);
                callback.loginRoom();
            }
        }
    }


    static class LiveRoomViewHolder extends RecyclerView.ViewHolder {

        private IRoomManagerCallback callback;
        private LiveRoomViewHolder(View itemView) {
            super(itemView);
            callback = (IRoomManagerCallback) itemView;
        }

    }
}
