package im.zego.liveshow.liveroom.view;

import android.content.Context;
import android.util.AttributeSet;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import im.zego.liveshow.R;
import im.zego.liveshow.utils.GlideLoader;

public class CloseRoomView extends FrameLayout {

    private ImageView mAnchorHeadPortrait;
    private View mCloseRoom;

    public CloseRoomView(@NonNull Context context) {
        this(context,null);
    }

    public CloseRoomView(@NonNull Context context, @Nullable AttributeSet attrs) {
        this(context, attrs,0);
    }

    public CloseRoomView(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        View view = View.inflate(context, R.layout.liveshow_live_room_close_room,this);
        initView();
    }

    private void initView(){
        mAnchorHeadPortrait = findViewById(R.id.anchor_head_portrait);
        mCloseRoom = findViewById(R.id.close_room);
    }

    public void update(String avatar){
        GlideLoader.displayCircleImageByAvatar(avatar, mAnchorHeadPortrait);
    }

    public void setCloseListener(OnClickListener listener){
        mCloseRoom.setOnClickListener(listener);
    }
}
