package im.zego.liveshow.liveroom.view;

import android.content.Context;
import android.util.AttributeSet;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.constraintlayout.widget.ConstraintLayout;

import im.zego.liveshow.R;
import im.zego.liveshow.model.UserInfo;
import im.zego.liveshow.utils.GlideLoader;

public class HostInfoView extends FrameLayout {


    private ImageView mAnchorHeadPortrait;
    private TextView mAnchorName;
    private TextView mTvOnlineNum;
    private View mCloseRoom;
    private ConstraintLayout mClOnlineNum;

    public HostInfoView(@NonNull Context context) {
        this(context,null);
    }

    public HostInfoView(@NonNull Context context, @Nullable AttributeSet attrs) {
        this(context, attrs,0);
    }

    public HostInfoView(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        View view = View.inflate(context, R.layout.liveshow_live_room_host_info,this);
        initView(view);
    }

    private void initView(View view){
        mAnchorHeadPortrait = findViewById(R.id.anchor_head_portrait);
        mAnchorName = findViewById(R.id.anchor_name);
        mTvOnlineNum = findViewById(R.id.tv_online_num);
        mCloseRoom = findViewById(R.id.close_room);
        mClOnlineNum = findViewById(R.id.cl_online_num);
    }

    public void update(UserInfo userInfo){
        GlideLoader.displayCircleImageByAvatar(userInfo.getAvatar(), mAnchorHeadPortrait);
        mAnchorName.setText(userInfo.getNickName());
    }

    public void updateOnlineNum(String onlineNum){
        mTvOnlineNum.setText(onlineNum);
    }


    public void setCloseListener(OnClickListener listener){
        mCloseRoom.setOnClickListener(listener);
    }

    public void setOnlineListener(OnClickListener listener){
        mClOnlineNum.setOnClickListener(listener);
    }



}
