package im.zego.liveshow.roomlist.view;

import android.content.Context;
import android.util.AttributeSet;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.FrameLayout;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.constraintlayout.widget.ConstraintLayout;

import im.zego.common.util.MiscUtils;
import im.zego.liveshow.R;


public class LoadMoreView extends FrameLayout {

    private ConstraintLayout mClLoadingMore;
    private ConstraintLayout mClLoadMoreFinish;


    public LoadMoreView(@NonNull Context context) {
        super(context);
        initView();
    }

    public LoadMoreView(@NonNull Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
        initView();
    }

    public LoadMoreView(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        initView();
    }

    public void initView()
    {
        View view = LayoutInflater.from(getContext()).inflate(R.layout.liveshow_view_load_more, this, true);
        mClLoadingMore = view.findViewById(R.id.cl_loading_more);
        mClLoadMoreFinish = view.findViewById(R.id.cl_load_more_finish);
        showLoading();
        LayoutParams layoutParams = new LayoutParams(new MarginLayoutParams(LayoutParams.MATCH_PARENT,LayoutParams.WRAP_CONTENT));
        view.setLayoutParams(layoutParams);
    }

    public void showLoading()
    {
        mClLoadingMore.setVisibility(VISIBLE);
        mClLoadMoreFinish.setVisibility(GONE);
    }

    public void showFinish()
    {
        mClLoadingMore.setVisibility(GONE);
        mClLoadMoreFinish.setVisibility(VISIBLE);
    }


}
