package im.zego.liveshow.sdk.callbacks;

import androidx.annotation.NonNull;

import im.zego.liveshow.model.rtc.NotifyApplyMicStateInfo;
import im.zego.liveshow.model.rtc.NotifyRefuseApplyMicInfo;
import im.zego.liveshow.model.rtc.NotifyUserListUpdateInfo;
import im.zego.liveshow.model.rtc.NotifyUserStateUpdateInfo;

public interface IRTCEventCallback {

    /**
     * 成员状态变更通知
     */
    void onUserStateUpdateNotify(@NonNull NotifyUserStateUpdateInfo notifyInfo);

    /**
     * 成员列表变更通知
     */
    void onUserListUpdateNotify(@NonNull NotifyUserListUpdateInfo notifyInfo);


    /**
     * 连麦申请
     */
    void onApplyMicStateNotify(@NonNull NotifyApplyMicStateInfo notifyInfo);

    /**
     * 取消申请
     */
    void onCancelApplyMicStateNotify(@NonNull NotifyApplyMicStateInfo notifyInfo);

    /**
     * 拒绝申请
     */
    void onRefuseApplyMicNotify(@NonNull NotifyRefuseApplyMicInfo notifyInfo);

    /**
     * 房间关闭通知
     */
    void onRoomCloseNotify();


}
