package im.zego.liveshow.sdk.model;

import android.view.TextureView;

import androidx.annotation.Nullable;

import im.zego.liveshow.sdk.callbacks.IRTCCommonCallback;
import im.zego.liveshow.sdk.callbacks.IStreamActiveCallback;

public class ZegoPlayStream extends ZegoStream{

    public ZegoPlayStream(String userID,String userName,String streamID){
       super(userID,userName,streamID);

        setCameraStatus(true);
        setMicPhoneStatus(true);
        setStreamActive(false);
    }

    @Override
    void enableVideo(boolean enable) {
        mStreamService.playWithVideo(mStreamID, enable);
    }

    @Override
    void enableAudio(boolean enable) {
        mStreamService.playWithAudio(mStreamID, enable);
    }

    @Override
    public void activeStream(TextureView view, IStreamActiveCallback activeResult) {
        if (mSteamStatus == STREAM_INIT) {
            mStreamService.startPlayStream(mStreamID, view, new IRTCCommonCallback() {
                @Override
                public void onRTCCallback(int errorCode) {
                    setStreamActive(errorCode == 0);
                    activeResult.onStreamActive(errorCode, mStreamID);
                }
            });
        }
    }

    @Override
    public void inActiveStream() {
        if (mSteamStatus == STREAM_START) {
            mStreamService.stopPlayStream(mStreamID);
        }
        setStreamActive(false);
    }

    @Override
    public boolean equals(@Nullable Object obj) {
        return mStreamID.equals(((ZegoStream)obj).mStreamID);
    }
}
