package im.zego.liveshow.utils;

import java.util.LinkedList;
import java.util.Queue;

import im.zego.liveshow.model.rtc.NotifyApplyMicStateInfo;

public class DialogQueue {

    private Queue<NotifyApplyMicStateInfo> mDialogQueue = new LinkedList<>();

    /**
     * 进队
     *
     * @param stateInfo
     */
    public void offer(NotifyApplyMicStateInfo stateInfo) {
        mDialogQueue.offer(stateInfo);
    }

    /**
     * 出队
     *
     * @return
     */
    public NotifyApplyMicStateInfo poll() {
        return mDialogQueue.poll();
    }

    /**
     * 判断当前对列没有数据，那就入队并且show()
     *
     * @return
     */
    public boolean canShow() {
        return mDialogQueue.size() == 0;
    }


    public void clear() {
        mDialogQueue.clear();
    }

    /**
     * 移除指定对象
     *
     * @param info
     */
    public void remove(NotifyApplyMicStateInfo info) {
        for (NotifyApplyMicStateInfo stateInfo : mDialogQueue) {
            if (info.getUid() == stateInfo.getUid()) {
                mDialogQueue.remove(stateInfo);
            }
        }
    }

    public Queue<NotifyApplyMicStateInfo> getmDialogQueue() {
        return mDialogQueue;
    }

    public void setmDialogQueue(Queue<NotifyApplyMicStateInfo> mDialogQueue) {
        this.mDialogQueue = mDialogQueue;
    }
}
