package im.zego.liveshow.view;

import android.content.DialogInterface;
import android.os.Bundle;
import android.widget.TextView;

import androidx.annotation.NonNull;

import org.jetbrains.annotations.NotNull;

import im.zego.liveshow.R;
import im.zego.liveshow.manager.RoomManager;
import im.zego.liveshow.model.StatefulListInfo;
import im.zego.liveshow.protocol.IExecuteCallback;

/**
 * 主播对于麦位的管理（移下麦、禁止发言、解除禁言）
 */
public class MicManagerDialog extends BaseBottomSheetDialogFragment {

    private TextView mTvMicStatus;
    private TextView mTvOnstageOff;
    private TextView mTvCancle;

    private StatefulListInfo.AttendeeListDTO userInfo;

    @Override
    public int getLayoutResId() {
        return R.layout.liveshow_dialog_mic_manager;
    }

    @Override
    public void initView(Bundle savedInstanceState) {

        mTvMicStatus = rootView.findViewById(R.id.tv_mic_status);
        mTvOnstageOff = rootView.findViewById(R.id.tv_onstage_off);
        mTvCancle = rootView.findViewById(R.id.tv_cancle);

        if (userInfo.getMic() == 1) { //1：关闭  2:打开
            mTvMicStatus.setText("解除禁言");
        } else if (userInfo.getMic() == 2) {
            mTvMicStatus.setText("禁止发言");
        }

        mTvCancle.setOnClickListener(v -> dismissAllowingStateLoss());

        mTvOnstageOff.setOnClickListener(v -> {
            RoomManager.getInstance().setMicStatusStatus(1, 1, 3, userInfo.getUid(), new IExecuteCallback() {
                @Override
                public void onSuccess() {
                    dismissAllowingStateLoss();
                }

                @Override
                public void onFailed(int errorCode) {

                }
            });
        });

        //如果房主打开弹窗  上麦观众再操作麦克风/摄像头 这个逻辑不准确
        mTvMicStatus.setOnClickListener(v -> {
            int mIsMicMuted = userInfo.getMic() == 1 ? 2 : 1;
            RoomManager.getInstance().setMicStatusStatus(mIsMicMuted, userInfo.getCamera(), 1, userInfo.getUid(), new IExecuteCallback() {
                @Override
                public void onSuccess() {
                    dismissAllowingStateLoss();
                }

                @Override
                public void onFailed(int errorCode) {

                }
            });
        });
    }

    public void setUserInfo(StatefulListInfo.AttendeeListDTO userInfo) {
        this.userInfo = userInfo;
        RoomManager.getInstance().setDialogIsShowInfo(userInfo);
    }


    public void setMic(int micStatus) {
        if (micStatus == 1) { //1：关闭  2:打开
            mTvMicStatus.setText("解除禁言");
        } else if (micStatus == 2) {
            mTvMicStatus.setText("禁止发言");
        }
        userInfo.setMic(micStatus);
    }

    @Override
    public void onDismiss(@NonNull @NotNull DialogInterface dialog) {
        super.onDismiss(dialog);
        RoomManager.getInstance().setDialogIsShowInfo(null);
    }


}
