package im.zego.common.proxy;

import android.content.Context;
import android.content.Intent;


import im.zego.zegoquality.ZegoQualityFactory;
import im.zego.zegoquality.ZegoQualityLanguageType;
import im.zego.zegoquality.ZegoQualityManager;

public class QualityManagerProxy {


    private static volatile QualityManagerProxy singleton = null;

    private QualityManagerProxy(){

    }

    public static QualityManagerProxy getInstance() {
        if (singleton == null) {
            synchronized (QualityManagerProxy.class) {
                if (singleton == null) {
                    singleton = new QualityManagerProxy();
                }
            }
        }
        return singleton;
    }


    public void init(Context context){
        ZegoQualityManager.getInstance().init(context.getApplicationContext());
    }

    public void setAppVersion(String version){
        ZegoQualityManager.getInstance().setAppVersion(version);
    }

    public void setPlayerStreamOnFirstFrame(String streamID){
        ZegoQualityManager.getInstance().setPlayerStreamOnFirstFrame(streamID);
    }

    public void parsingLog(String content){
        ZegoQualityManager.getInstance().parsingLog(content);
    }

    public void setLoginOnFinish(){
        ZegoQualityManager.getInstance().setLoginOnFinish();
    }

    public void setPlayerStreamOnStart(String streamID){
        ZegoQualityManager.getInstance().setPlayerStreamOnStart(streamID);
    }

    public void setPublishStreamID(String streamID){
        ZegoQualityManager.getInstance().setPublishStreamID(streamID);
    }

    public void setLoginOnStart() {
        ZegoQualityManager.getInstance().setLoginOnStart();
    }

    public void setLanguageType(boolean isChinese){
        if(isChinese){
            ZegoQualityManager.getInstance().setLanguageType(ZegoQualityLanguageType.ZegoQualityLanguageTypeChinese);
        }else {
            ZegoQualityManager.getInstance().setLanguageType(ZegoQualityLanguageType.ZegoQualityLanguageTypeEnglish);
        }
    }

    public void setProductName(String productName){
        ZegoQualityManager.getInstance().setProductName(productName);
    }

    public void setUserName(String userName){
        ZegoQualityManager.getInstance().setUserName(userName);
    }

    public void setUserID(String userID){
        ZegoQualityManager.getInstance().setUserID(userID);
    }

    public void setRoomID(String roomID){
        ZegoQualityManager.getInstance().setRoomID(roomID);
    }

    public static Intent getQualityIntent(Context context){
        return ZegoQualityFactory.getQualityIntent(context);
    }

}
