package im.zego.common.view;

import android.graphics.Rect;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import androidx.recyclerview.widget.RecyclerView.Adapter;
import androidx.recyclerview.widget.StaggeredGridLayoutManager;

import static androidx.recyclerview.widget.LinearLayoutManager.*;

public class FinallyItemDecoration extends RecyclerView.ItemDecoration {

    private int mHeightPx = 0;

    public FinallyItemDecoration(int heightPx)
    {
        mHeightPx = heightPx;
    }


    @Override
    public void getItemOffsets(@NonNull Rect outRect, @NonNull View view, @NonNull RecyclerView parent, @NonNull RecyclerView.State state) {

        Adapter adapter  = parent.getAdapter();
        int  childCount = adapter.getItemCount()-1;
        int spanCount = getSpanCount(parent);
        if(childCount == parent.getChildAdapterPosition(view)) {
            if(parent.getLayoutManager() instanceof LinearLayoutManager){
                LinearLayoutManager layoutManager = (LinearLayoutManager) parent.getLayoutManager();
                if (layoutManager.getOrientation() == HORIZONTAL) {
                    outRect.right = mHeightPx;
                } else if (layoutManager.getOrientation()  == VERTICAL) {
                    outRect.bottom = mHeightPx;
                }
            }
        }

    }

    private int getSpanCount(RecyclerView parent) {
        // 列数
        int spanCount = -1;
        RecyclerView.LayoutManager layoutManager = parent.getLayoutManager();
        if (layoutManager instanceof GridLayoutManager) {
            spanCount = ((GridLayoutManager) layoutManager).getSpanCount();
        } else if (layoutManager instanceof StaggeredGridLayoutManager) {
            spanCount = ((StaggeredGridLayoutManager) layoutManager)
                    .getSpanCount();
        }
        return spanCount;
    }

}
