package im.zego.gochat.custom;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.PopupWindow;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import im.zego.gochat.R;
import im.zego.gochat.chatroom.adapter.RaiseHandAdapter;
import im.zego.gochat.utils.MiscUtils;

/**
 * 举手列表
 */
public class RaiseHandListPopWindow extends PopupWindow {
    private RecyclerView recyclerView;
    private RaiseHandAdapter adapter;
    private View emptyView;

    public RaiseHandListPopWindow(Context context) {
        init(context);
    }

    private void init(Context context) {
        View view = LayoutInflater.from(context).inflate(R.layout.pop_raise_hand, null, false);

        recyclerView = view.findViewById(R.id.rv_raise_hand_list);
        emptyView = view.findViewById(R.id.raise_hand_list_empty);
        adapter = new RaiseHandAdapter();
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(context);
        recyclerView.setLayoutManager(linearLayoutManager);
        recyclerView.setAdapter(adapter);
        setContentView(view);
        setOutsideTouchable(true);
        setWidth(ViewGroup.LayoutParams.MATCH_PARENT);
        setHeight(MiscUtils.dp2px(context, 335f));
    }

    public void initRaiseHandList() {
        emptyView.setVisibility(View.GONE);
        recyclerView.setVisibility(View.VISIBLE);
        adapter.initRaiseHandList();
    }
}
