package im.zego.gochat.rtc.callbacks;

import org.jetbrains.annotations.NotNull;

import java.util.HashMap;

import im.zego.gochat.model.NotifyInvitedInfo;
import im.zego.gochat.model.NotifyRefuseInviteInfo;
import im.zego.gochat.model.NotifyUserStateUpdateInfo;
import im.zego.gochat.model.NotifyUserListUpdateInfo;

public interface IRTCEventCallback {
    /**
     * 成员列表变更通知
     */
    void onUserListUpdateNotify(@NotNull NotifyUserListUpdateInfo notifyInfo);

    /**
     * 成员状态变更通知
     */
    void onUserStateUpdateNotify(@NotNull NotifyUserStateUpdateInfo notifyInfo);

    /**
     * 收到邀请的通知
     */
    void onInvitedNotify(@NotNull NotifyInvitedInfo notifyInfo);

    /**
     * 拒绝邀请通知
     */
    void onRefusedInviteNotify(@NotNull NotifyRefuseInviteInfo notifyInfo);

    /**
     * 房间关闭通知
     */
    void onRoomCloseNotify();

    /**
     * 借助RTC SDK判断房间断线重连
     */
    void onRoomReconnected();

    void onUserVolumeUpdate(HashMap<Long, Float> userVolumeMap);
}
