package im.zego.gochat.utils;

import android.graphics.drawable.Drawable;
import android.util.Log;
import android.widget.ImageView;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.engine.DiskCacheStrategy;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;

import im.zego.gochat.R;

public class GlideImageLoader {

    private int[] res = {
            R.drawable.user1, R.drawable.user2, R.drawable.user3, R.drawable.user4, R.drawable.user5,
            R.drawable.user6, R.drawable.user7, R.drawable.user8, R.drawable.user9, R.drawable.user10,
            R.drawable.user11, R.drawable.user12, R.drawable.user13, R.drawable.user14, R.drawable.user15,
            R.drawable.user16, R.drawable.user17, R.drawable.user18, R.drawable.user19, R.drawable.user20};


    /**
     * 单例
     */
    private static volatile GlideImageLoader mInstance;

    private GlideImageLoader() {
    }

    public static GlideImageLoader getInstance() {
        if (mInstance == null) {
            synchronized (GlideImageLoader.class) {
                if (mInstance == null) {
                    mInstance = new GlideImageLoader();
                    return mInstance;
                }
            }
        }
        return mInstance;
    }


    /**
     * 在一个imageView里面异步展示一个图片
     *
     * @param url
     * @param imageView
     */
    public void displayImage(String url, ImageView imageView) {
        if (url == null || url.isEmpty()) {
            return;
        }
        Glide.with(imageView.getContext())
                .load(url)
                .dontAnimate()
                .diskCacheStrategy(DiskCacheStrategy.ALL) // 设置缓存的策略
                .into(imageView);
    }

    /**
     * 在一个imageView里面异步展示一个图片
     *
     * @param resourceId
     * @param imageView
     */
    private void displayImage(int resourceId, ImageView imageView) {
        Glide.with(imageView.getContext())
                .load(resourceId)
                .dontAnimate()
                .diskCacheStrategy(DiskCacheStrategy.ALL) // 设置缓存的策略
                .into(imageView);
    }


    public String getAvatarByNickname(String nickname) {
        return String.valueOf(getValue(nickname));
    }

    public void displayImageByAvatar(String avatar, ImageView imageView) {
        try {
            int a = Integer.parseInt(avatar);
            displayImage(res[(a-1)%20], imageView);
        }catch (Exception e)
        {
            displayImage(res[0],imageView);
        }

    }

    public static byte[] md5(String input) throws NoSuchAlgorithmException {
        return  MessageDigest.getInstance("MD5").digest(input.getBytes());
    }

    public static int getValue(String input) {

        byte b[] ;
        try {
            b = md5(input);
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
            return 0;
        }

        if(b.length > 0)
        {
            int a = Math.abs(b[0] % 20) + 1;
            return a;
        }else {
            return 0;
        }
    }


}
