package im.zego.ktv.chorus.base;

public class Constants {
    public static final int MAX_STAGE_NUM = 8;
    public static final String ROOM_SUBJECT = "subject";
    public static final String LYRIC_FORMAT = "lrc";
    public static final String MAIN_STREAM_SURFIX = "_main";
    public static final int SOUND_ID_SURFIX_NUM = 5;
    public static final String MV_STREAM_SURFIX = "_mv";
    public static final String MIX_STREAM_SURFIX = "_mix";
    public final static String KEY_PROCESS_IN_MS = "kProgressKey";
    public final static String KEY_Total_IN_MS = "kTotalKey";
    public final static String KEY_MV_STATE = "kState";
    public final static String KEY_NTP_TIME_STAMP = "kPointTimeKey";
    public final static String KEY_MV_PLAY_NTP = "kPlayTime";
    public final static String KEY_Song_Id = "kSongID";
    public final static String KEY_ROLE = "kRole";
    public final static int PERMISSION_REQUEST_CODE = 0x1000;
    public final static int LOGIN_MAX_TRY_TIME = 3;
    public final static long COMMAND_TAKE_EFFECT_GAP = 1000;
    final public static int SAMPLE_NUM_IN_GROUP = 10;
    final public static int SAMPLE_NUM_IN_GROUP_SPEED_TEST = 3;
    final public static int BAD_PACKET_LOSS = 15;
    final public static int FINE_PACKET_LOSS = 10;
    final public static int BAD_RTT = 60;
    final public static int FINE_RTT = 40;
    public static enum MediaPlayerBehavior {
        PLAYING(0),
        PAUSE(1),
        STOP(2),
        RESUME(3);

        private final int value;

        MediaPlayerBehavior(int value) {
            this.value = value;
        }

        public int value() {
            return this.value;
        }

        public static MediaPlayerBehavior getMediaPlayerBehavior(int value) {
            if (PLAYING.value == value) {
                return PLAYING;
            } else {
                return STOP.value == value ? STOP : null;
            }
        }
    }
    public static enum OperationType{
        MIC(1),
        OFF_STAGE(2),
        ON_STAGE(3),
        ORIGINAL(4),
        NEXT_SONG(5),
        SELECT_SONG(6),
        CANCEL_SONG(7),
        GET_ONSTAGE_USERS(8),
        CLOSE_ROOM(9),
        GET_ORDERED_SONGS(10);
        private final int value;

        private OperationType(int value) {
            this.value = value;
        }

        public int value() {
            return this.value;
        }
    }



}

