package im.zego.ktv.chorus.custom;

import android.content.Context;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.constraintlayout.widget.ConstraintLayout;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import im.zego.ktv.R;
import im.zego.ktv.chorus.ktvroom.KTVRoomOrderSongManager;
import im.zego.ktv.chorus.ktvroom.adapter.WaitListAdapter;
import im.zego.ktv.chorus.roomlist.adapter.EmptyAndLoadMoreAdapterWrapper;

/**
 * 已点列表
 */
public class WaitListView extends ConstraintLayout {

    private RecyclerView mWaitList;

    private WaitListAdapter mAdapter;
    private EmptyAndLoadMoreAdapterWrapper mAdapterWrapper;

    public WaitListView(@NonNull Context context) {
        this(context, null);
    }

    public WaitListView(@NonNull Context context, @Nullable AttributeSet attrs) {
        this(context, attrs, 0);
    }

    public WaitListView(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);

        View view = View.inflate(context, R.layout.ktv_view_wait_list,this);
        mWaitList = view.findViewById(R.id.wait_list);

        initRecycleView();
        initData();
    }

    private void initRecycleView(){

        mAdapter = new WaitListAdapter(getContext());
        mWaitList.setLayoutManager(new LinearLayoutManager(getContext(), LinearLayoutManager.VERTICAL,false));


        View emptyView = LayoutInflater.from(getContext()).inflate(R.layout.ktv_view_ordered_empty_list,mWaitList, false);
        View view = new View(getContext());
        mAdapterWrapper = new EmptyAndLoadMoreAdapterWrapper(mAdapter);
        mAdapterWrapper.setEmptyView(emptyView);
        mAdapterWrapper.setLoadMoreView(view);
        mWaitList.setAdapter(mAdapterWrapper);

    }

    private void initData(){
        mAdapter.setData(KTVRoomOrderSongManager.getInstance().getOrderList());
        mAdapterWrapper.notifyDataSetChanged();
    }

    public void notifyData(){
        mAdapter.setData(KTVRoomOrderSongManager.getInstance().getOrderList());
        mAdapterWrapper.notifyDataSetChanged();
    }




}
