package im.zego.ktv.chorus.ktvroom.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import java.util.ArrayList;
import java.util.List;

import im.zego.ktv.R;

public class SongListTipsAdapter extends RecyclerView.Adapter<SongListTipsAdapter.SearchTipsHolder> {


    private List<String> mSearchTips = new ArrayList<>();

    @NonNull
    @Override
    public SearchTipsHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.ktv_search_song_item, parent, false);
        return new SearchTipsHolder(view);
    }


    @Override
    public void onBindViewHolder(@NonNull SearchTipsHolder holder, int position) {
        String searchTips = mSearchTips.get(position);
        holder.mTvSearchName.setText(searchTips);
        holder.itemView.setOnClickListener(v -> {
            if (onTipsItemClickListener != null) {
                onTipsItemClickListener.onClick(searchTips);
            }
        });
    }

    @Override
    public int getItemCount() {
        return mSearchTips.size();
    }


    static class SearchTipsHolder extends RecyclerView.ViewHolder {

        private TextView mTvSearchName;

        public SearchTipsHolder(@NonNull View itemView) {
            super(itemView);
            mTvSearchName = itemView.findViewById(R.id.tv_search_name);
        }

    }

    public void initTipsList(List<String> list) {
        mSearchTips = list;
        notifyDataSetChanged();
    }

    public void clearData() {
        this.mSearchTips.clear();
        notifyDataSetChanged();
    }

    private OnTipsItemClickListener onTipsItemClickListener;

    public void setOnTipsItemClickListener(OnTipsItemClickListener onTipsItemClickListener) {
        this.onTipsItemClickListener = onTipsItemClickListener;
    }

    public interface OnTipsItemClickListener {
        void onClick(String searchTips);
    }

}
