package im.zego.ktv.chorus.ktvroom.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import java.util.ArrayList;
import java.util.List;

import im.zego.ktv.R;
import im.zego.ktv.chorus.model.SongCategoryBean;


public class SongTypeAdapter extends RecyclerView.Adapter<SongTypeAdapter.SongTypeViewHolder> {

    private List<SongCategoryBean> mData = new ArrayList<>();
    private Context context;

    private int selectItem = 0;//默认选中值
    private OnItemListener onItemListener;

    public SongTypeAdapter(Context context, List<SongCategoryBean> mData) {
        this.context = context;
        this.mData = mData;
    }

    public void setOnItemListener(OnItemListener onItemListener) {
        this.onItemListener = onItemListener;
    }

    public interface OnItemListener {
        void onClick(int position, SongCategoryBean songCategoryBean);
    }

    public void setSelectItem(int selectItem) {
        this.selectItem = selectItem;
        notifyDataSetChanged();
    }

    @NonNull
    @Override
    public SongTypeViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.ktv_item_song_type, parent, false);
        return new SongTypeViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull SongTypeViewHolder holder, int position) {

        SongCategoryBean songCategoryBean = mData.get(position);

        holder.tvSongType.setText(songCategoryBean.getCategoryName());
        if (selectItem == position) {  //选中
            holder.tvSongType.setBackgroundResource(R.drawable.ktv_shape_ffffffff_14);
            holder.tvSongType.setTextColor(context.getResources().getColor(R.color.ktv_color_ffff3571));
        } else {
            holder.tvSongType.setBackgroundResource(R.drawable.ktv_shape_ff3e1b71_14);
            holder.tvSongType.setTextColor(context.getResources().getColor(R.color.ktv_color_ffdac1ff));
        }

        holder.itemView.setOnClickListener(v -> {
            if (onItemListener != null) {
                onItemListener.onClick(position, songCategoryBean);
            }
        });

    }

    @Override
    public int getItemCount() {
        if (mData == null) {
            return 0;
        }
        return mData.size();
    }


    class SongTypeViewHolder extends RecyclerView.ViewHolder {

        private TextView tvSongType;

        private SongTypeViewHolder(View view) {
            super(view);

            tvSongType = view.findViewById(R.id.tv_song_type);

        }
    }


}
