package im.zego.ktv.chorus.model;

import com.google.gson.annotations.SerializedName;

import java.util.List;

/**
 * 歌曲列表
 */
public class SongCategoryListBean {

    @SerializedName("total")
    private String total; //总条数

    @SerializedName("songs")
    private List<SongListDTO> songsList;

    public String getTotal() {
        return total;
    }

    public List<SongListDTO> getSongsList() {
        return songsList;
    }

    public static class SongListDTO {

        @SerializedName("singer_img")
        private String singerImg; //歌手头像

        @SerializedName("album_img")
        private String albumImg; //专辑封面

        @SerializedName("album_img_small")
        private String albumImgSmall; //专辑封面300px左右

        @SerializedName("has_accompany")
        private int hasAccompany; //是否有伴奏。0：否 1.是

        @SerializedName("song_id")
        private String songId; //歌曲id

        @SerializedName("song_name")
        private String songName; //歌曲名

        @SerializedName("singer_id")
        private String singerId; //歌手id

        @SerializedName("singer_name")
        private String singerName; //歌手名

        @SerializedName("album_id")
        private String albumId; //歌曲所属专辑id

        @SerializedName("album_name")
        private String albumName; //歌曲所属专辑名

        @SerializedName("copyright")
        private Copyright copyright; //歌曲所属专辑名


        public String getSingerImg() {
            return singerImg;
        }

        public void setSingerImg(String singerImg) {
            this.singerImg = singerImg;
        }

        public String getAlbumImg() {
            return albumImg;
        }

        public void setAlbumImg(String albumImg) {
            this.albumImg = albumImg;
        }

        public String getAlbumImgSmall() {
            return albumImgSmall;
        }

        public void setAlbumImgSmall(String albumImgSmall) {
            this.albumImgSmall = albumImgSmall;
        }

        public int getHasAccompany() {
            return hasAccompany;
        }

        public void setHasAccompany(int hasAccompany) {
            this.hasAccompany = hasAccompany;
        }

        public String getSongId() {
            return songId;
        }

        public void setSongId(String songId) {
            this.songId = songId;
        }

        public String getSongName() {
            return songName;
        }

        public void setSongName(String songName) {
            this.songName = songName;
        }

        public String getSingerId() {
            return singerId;
        }

        public void setSingerId(String singerId) {
            this.singerId = singerId;
        }

        public String getSingerName() {
            return singerName;
        }

        public void setSingerName(String singerName) {
            this.singerName = singerName;
        }

        public String getAlbumId() {
            return albumId;
        }

        public void setAlbumId(String albumId) {
            this.albumId = albumId;
        }

        public String getAlbumName() {
            return albumName;
        }

        public void setAlbumName(String albumName) {
            this.albumName = albumName;
        }

        public Copyright getCopyright() {
            return copyright;
        }

        public void setCopyright(Copyright copyright) {
            this.copyright = copyright;
        }
    }


    public static class Copyright {

        @SerializedName("ciqu")
        private int ciqu; //词曲权限 非0有权

        @SerializedName("luyin")
        private int luyin; //录音权限 非0有权

        public int getCiqu() {
            return ciqu;
        }

        public void setCiqu(int ciqu) {
            this.ciqu = ciqu;
        }

        public int getLuyin() {
            return luyin;
        }

        public void setLuyin(int luyin) {
            this.luyin = luyin;
        }
    }


}
