package im.zego.ktv.chorus.model;

import com.google.gson.annotations.SerializedName;

import java.util.Objects;

public class UserInfo {
    @SerializedName("room_id")
    private String roomId;

    @SerializedName("uid")
    private long uid;

    @SerializedName("nick_name")
    private String nickName;

    @SerializedName("avatar")
    private String avatar;

    @SerializedName("role")
    // 1、观众  2、嘉宾 3、主持人
    private int role;

    @SerializedName("login_timestamp")
    // 用户进入房间的时间戳
    private long loginTimeStamp;

    @SerializedName("mic")
    private int mic;

    @SerializedName("onstage_state")
    //1:不在台上  2：在台上
    private int onstageState;

    @SerializedName("mic_index")
    //麦位号
    private int micIndex;

    public UserInfo(long uid, String nickName, int role){
        this.uid = uid;
        this.nickName = nickName;
        this.role = role;
    }
    public UserInfo(){
    }


    public UserInfo setRoomID(String roomId) {
        this.roomId = roomId;
        return this;
    }

    public long getUserID() {
        return uid;
    }

    public UserInfo setUid(long uid) {
        this.uid = uid;
        return this;
    }

    public String getNickName() {
        return nickName;
    }

    public UserInfo setNickName(String nickName) {
        this.nickName = nickName;
        return this;
    }

    public String getAvatar() {
        return avatar;
    }

    public UserInfo setAvatar(String avatar) {
        this.avatar = avatar;
        return this;
    }

    public int getRole() {
        return role;
    }

    public UserInfo setRole(int role) {
        this.role = role;
        return this;
    }

    public long getLoginTimeStamp() {
        return loginTimeStamp;
    }

    public UserInfo setLoginTimeStamp(long loginTimeStamp) {
        this.loginTimeStamp = loginTimeStamp;
        return this;
    }

    public boolean isMicOpen() {
        return mic == 2;
    }

    public UserInfo setMicOpen(boolean micOpen) {
        mic = (micOpen ? 2 : 1);
        return this;
    }

    public int getMic() {
        return mic;
    }

    public int getOnstageState() {
        return onstageState;
    }

    public UserInfo setOnstageState(int onstageState) {
        this.onstageState = onstageState;
        return this;
    }

    public int getMicIndex() {
        return micIndex;
    }

    public UserInfo setMicIndex(int index) {
        this.micIndex = index;
        return this;
    }


    public boolean isHost() {
        return role == 3;
    }

    public boolean isStageGuest() {
        return role == 2;
    }

    public boolean isAudience() {
        return role == 1;
    }

    public boolean isOnstage (){
        return (onstageState == 2);
    }

    public void update(UserInfo changedUserInfo) {
        nickName = changedUserInfo.nickName;
        avatar = changedUserInfo.avatar;
        role = changedUserInfo.role;
        loginTimeStamp = changedUserInfo.loginTimeStamp;
        mic = changedUserInfo.mic;
        onstageState = changedUserInfo.onstageState;
        micIndex = changedUserInfo.micIndex;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        UserInfo userInfo = (UserInfo) o;
        return uid == userInfo.uid;
    }

    @Override
    public int hashCode() {
        return Objects.hash(uid);
    }
}
