package im.zego.ktv.chorus.model.notify;

import com.google.gson.annotations.SerializedName;

import java.util.ArrayList;

import im.zego.ktv.chorus.model.UserInfo;

/**
 * 用户列表变更通知
 */
public class NotifyUserListUpdateInfo {
    @SerializedName("online_num")
    public int onlineNum;
    @SerializedName("seq")
    public String seq;

    @SerializedName("users")
    public ArrayList<UserUpdateInfo> users;

    public static class UserUpdateInfo {
        @SerializedName("room_id")
        public long roomId;

        @SerializedName("uid")
        public long uid;

        @SerializedName("nick_name")
        public String nickName;

        @SerializedName("avatar")
        public String avatar;

        @SerializedName("role")
        public int role;

        @SerializedName("delta")
        public int delta;

        @SerializedName("login_timestamp")
        public long loginTimeStamp;

        @SerializedName("onstage_state")
        public int onstageState;

        @SerializedName("mic")
        public int mic;

        @SerializedName("mic_index")
        public int micIndex;

        public boolean isHost() {
            return role == 3;
        }

        public boolean isStageGuest() {
            return role == 2;
        }

        public boolean isAudience() {
            return role == 1;
        }

        public boolean isOnstage (){
            return onstageState==2;
        }

        /**
         * 将成员列表通知model转换为通用userinfo
         *
         * @param updateInfo
         * @return
         */
        public UserInfo toUserInfo(UserUpdateInfo updateInfo) {
            UserInfo info = new UserInfo()
                    .setAvatar(updateInfo.avatar)
                    .setMicOpen(updateInfo.mic == 2)
                    .setLoginTimeStamp(updateInfo.loginTimeStamp)
                    .setNickName(updateInfo.nickName)
                    .setOnstageState(updateInfo.onstageState)
                    .setUid(updateInfo.uid)
                    .setRole(updateInfo.role);
            return info;
        }
    }


}
