package im.zego.ktv.chorus.model.notify;

import com.google.gson.annotations.SerializedName;

import java.util.ArrayList;

import im.zego.ktv.chorus.model.UserInfo;

public class NotifyUserStateUpdateInfo {
    @SerializedName("operator_uid")
    public long operatorUid;

    @SerializedName("operator_name")
    public String operatorName;

    @SerializedName("type")
    public int type;

    @SerializedName("gb_personal_state_seq")
    public int globalPersonalStateSeq;

    @SerializedName("timestamp")
    public long timestamp;

    @SerializedName("users")
    public ArrayList<UserInfo> users;

    public static class UserStateInfo {
        @SerializedName("room_id")
        private String roomID;

        @SerializedName("uid")
        private long uid;
        public long getUserID() {
            return uid;
        }

        @SerializedName("nick_name")
        private String nickName;
        public String getNickName() {
            return nickName;
        }

        @SerializedName("avatar")
        private String avatar;

        @SerializedName("role")
        private int role;
        public int getRole() {
            return role;
        }
        public boolean isHost() {
            return role == 3;
        }
        public boolean isStageGuest() {
            return role == 2;
        }
        public boolean isAudience() {
            return role == 1;
        }

        @SerializedName("login_timestamp")
        private long loginTimestamp;

        @SerializedName("onstage_state")
        private int onstageState;


        @SerializedName("mic")
        private int mic;

        @SerializedName("mic_index")
        private int micIndex;

        public UserInfo toUserInfo() {
            return new UserInfo()
                    .setRoomID(roomID)
                    .setUid(uid)
                    .setNickName(nickName)
                    .setAvatar(avatar)
                    .setRole(role)
                    .setMicIndex(micIndex)
                    .setLoginTimeStamp(loginTimestamp)
                    .setMicOpen(mic == 2)
                    .setOnstageState(onstageState);
        }
    }
}
