package im.zego.ktv.chorus.rtc;


import android.text.TextUtils;

import com.google.gson.Gson;

import java.util.HashMap;
import java.util.Map;

import im.zego.common.util.L;
import im.zego.lyricview.model.ZGKTVLyric;

public class ZGKTVLyricManager {

    private static final String TAG = "ZGKTVLyricManager";

    private Gson gson = new Gson();
    private Map<String,ZGKTVLyric> mLyricMap = new HashMap<>();


    private static volatile ZGKTVLyricManager mInstance = new ZGKTVLyricManager();


    private ZGKTVLyricManager(){
    }


    public static ZGKTVLyricManager getInstance() {
        if (mInstance == null) {
            synchronized (ZGKTVLyricManager.class) {
                if (mInstance == null) {
                    mInstance = new ZGKTVLyricManager();
                }
            }
        }
        return mInstance;
    }


    public ZGKTVLyric getLyric(String songID){
        return mLyricMap.get(songID);
    }

    public void putLyric(String songID,String lyric){
        try {
            putLyric(songID,gson.fromJson(lyric,ZGKTVLyric.class));
        }catch (Exception e){

        }

    }

    public void putLyric(String songID,ZGKTVLyric lyric){
        L.i("CopyrightedMusicManager","putLyric :songID:" + songID + "lyric 为空" + (lyric == null) );
        L.i(TAG,"putLyric :songID:" + songID + "lyric 为空" + (lyric == null) );
        if(lyric == null){
            lyric = new ZGKTVLyric();
            lyric.setLrcFormat("[00:00.00]未获得歌词");
        }

        if(TextUtils.isEmpty(lyric.getLrcFormat())){
            lyric.setLrcFormat("[00:00.00]未获得歌词");
        }


        mLyricMap.put(songID,lyric);
        ZGKTVCopyrightedSong song = ZGKTVPlayerManager.getInstance().getSong(songID);
        if(song != null){
            song.setLyric(lyric);
        }

    }

    public void clearData(){
        mLyricMap.clear();
    }

}
