package im.zego.ktv.chorus.rtc;


import com.google.gson.Gson;

import java.util.HashMap;
import java.util.Map;

import im.zego.common.util.L;
import im.zego.pitchview.model.ZGKTVPitch;

public class ZGKTVPitchManager {

    private static final String TAG = "ZGKTVPitchManager";

    private final Gson gson = new Gson();
    private final Map<String, ZGKTVPitch> mPitchMap = new HashMap<>();


    private static volatile ZGKTVPitchManager mInstance = new ZGKTVPitchManager();


    private ZGKTVPitchManager(){
    }


    public static ZGKTVPitchManager getInstance() {
        if (mInstance == null) {
            synchronized (ZGKTVPitchManager.class) {
                if (mInstance == null) {
                    mInstance = new ZGKTVPitchManager();
                }
            }
        }
        return mInstance;
    }


    public ZGKTVPitch getPitch(String songID){
        return mPitchMap.get(songID);
    }

    public void putPitch(String songID,String lyric){
        try {
            putPitch(songID,gson.fromJson(lyric,ZGKTVPitch.class));
        }catch (Exception e){

        }

    }

    public void putPitch(String songID,ZGKTVPitch pitch){
        L.i(TAG,"putPitch :songID:" + songID + "pitch 为空" + (pitch == null) );


        mPitchMap.put(songID,pitch);
//        ZGKTVCopyrightedSong song = ZGKTVPlayerManager.getInstance().getSong(songID);
//        if(song != null){
//            song.setLyric(pitch);
//        }

    }

    public void clearData(){
        mPitchMap.clear();
    }

}
