package im.zego.ktv.chorus.viewmodel;

import android.os.Looper;

import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.ViewModel;

import im.zego.ktv.chorus.model.AdjustTypeBean;
import im.zego.ktv.chorus.model.UserDataMonitorInfo;
import im.zego.ktv.chorus.model.UserInfo;

public class KTVRoomViewModel extends ViewModel {
    private MutableLiveData<String> mAvatar = new MutableLiveData<>();
    private MutableLiveData<Long> mTotalTime = new MutableLiveData<>();
    private MutableLiveData<Long> mPlayTime = new MutableLiveData<>();
    private MutableLiveData<UserInfo> mHostUser = new MutableLiveData<>();
    private MutableLiveData<UserInfo> mMyInfo = new MutableLiveData<>();
    private MutableLiveData<String> mSubject = new MutableLiveData<>();
    private MutableLiveData<Integer> mSongType = new MutableLiveData<Integer>();
    private MutableLiveData<UserDataMonitorInfo> mMonitorInfoMutableLiveData = new MutableLiveData<UserDataMonitorInfo>(new UserDataMonitorInfo());
    private MutableLiveData<UserDataMonitorInfo> mMyMonitorInfoMutableLiveData = new MutableLiveData<UserDataMonitorInfo>(new UserDataMonitorInfo());


    public final MutableLiveData<AdjustTypeBean> mAdjustType = new MutableLiveData<>();
    public final MutableLiveData<Boolean>  mNeedShowAdjustView = new MutableLiveData<>(false);


    public MutableLiveData<Integer> getSongType() {
        return mSongType;
    }

    public void setSongType(int type) {
        if(Looper.myLooper() == Looper.getMainLooper()){
            mSongType.setValue(type);
        }else{
            mSongType.postValue(type);
        }
    }


    public void setPlayTime(Long playTime) {
        if(Looper.myLooper() == Looper.getMainLooper()){
            mPlayTime.setValue(playTime);
        }else{
            mPlayTime.postValue(playTime);
        }
    }

    public void setTotalTime(Long totalTime) {
        if(Looper.myLooper() == Looper.getMainLooper()){
            mTotalTime.setValue(totalTime);
        }else{
            mTotalTime.postValue(totalTime);
        }
    }

    public MutableLiveData<Boolean> getNeedShowAdjustView() {
        return mNeedShowAdjustView;
    }
    public void setNeedShowAdjustView(Boolean show) {
        if (Looper.getMainLooper() == Looper.myLooper()) {
            this.mNeedShowAdjustView.setValue(show);
        } else {
            this.mNeedShowAdjustView.postValue(show);
        }
    }


    public MutableLiveData<AdjustTypeBean> getAdjustType() {
        return mAdjustType;
    }
    public void setAdjustType(AdjustTypeBean bean) {
        if (Looper.getMainLooper() == Looper.myLooper()){
            this.mAdjustType.setValue(bean);
        } else {
            this.mAdjustType.postValue(bean);
        }
    }

    public void setAvatar(String avatar) {
        if (Looper.getMainLooper() == Looper.myLooper()){
            this.mAvatar.setValue(avatar);
        } else {
            this.mAvatar.postValue(avatar);
        }
    }

    public void setSubject(String subject) {
        if (Looper.getMainLooper() == Looper.myLooper()){
            this.mSubject.setValue(subject);
        } else {
            this.mSubject.postValue(subject);
        };
    }

    public void setHostUser(UserInfo userInfo) {
        if (Looper.getMainLooper() == Looper.myLooper()){
            this.mHostUser.setValue(userInfo);
        } else {
            this.mHostUser.postValue(userInfo);
        }
    }

    public MutableLiveData<String> getSubject() {
        return mSubject;
    }

    public MutableLiveData<UserInfo> getHostUser() {
        return mHostUser;
    }

    public MutableLiveData<String> getAvatar() {
        return mAvatar;
    }

    public MutableLiveData<Long> getPlayTime() {
        return mPlayTime;
    }

    public MutableLiveData<Long> getTotalTime() {
        return mTotalTime;
    }

    public void setMyInfo(UserInfo myInfo) {
        if (Looper.getMainLooper() == Looper.myLooper()){
            this.mMyInfo.setValue(myInfo);
        } else {
            this.mMyInfo.postValue(myInfo);
        };
    }

    public MutableLiveData<UserInfo> getMyInfo() {
        return mMyInfo;
    }



    public void setHostPlayQuality(long rtt, long peerToPeerDelay, double packetLostRate) {
        UserDataMonitorInfo userDataMonitorInfo = mMonitorInfoMutableLiveData.getValue();
        userDataMonitorInfo.setRtt(rtt);
        userDataMonitorInfo.setPeerToPeerDelay(peerToPeerDelay);
        userDataMonitorInfo.setPacketLoss(packetLostRate);
        if (Looper.getMainLooper() == Looper.myLooper()){
            this.mMonitorInfoMutableLiveData.setValue(userDataMonitorInfo);
        } else {
            this.mMonitorInfoMutableLiveData.postValue(userDataMonitorInfo);
        };
    }

    public MutableLiveData<UserDataMonitorInfo> getMonitorInfoMutableLiveData() {
        return mMonitorInfoMutableLiveData;
    }

    public MutableLiveData<UserDataMonitorInfo> getMyMonitorInfoMutableLiveData() {
        return mMyMonitorInfoMutableLiveData;
    }

    public void setMyMonitorInfoMutableLiveData(UserDataMonitorInfo myMonitorInfoMutableLiveData) {
        if (Looper.getMainLooper() == Looper.myLooper()){
            this.mMyMonitorInfoMutableLiveData.setValue(myMonitorInfoMutableLiveData);
        } else {
            this.mMyMonitorInfoMutableLiveData.postValue(myMonitorInfoMutableLiveData);
        };
    }

    public void setHostMonitorInfoMutableLiveData(UserDataMonitorInfo hostMonitorInfoMutableLiveData) {
        if (Looper.getMainLooper() == Looper.myLooper()){
            this.mMonitorInfoMutableLiveData.setValue(hostMonitorInfoMutableLiveData);
        } else {
            this.mMonitorInfoMutableLiveData.postValue(hostMonitorInfoMutableLiveData);
        };
    }
}
