package im.zego.ktv.custom;

import android.content.Context;
import android.util.AttributeSet;
import android.view.MotionEvent;

import androidx.appcompat.widget.AppCompatSeekBar;


public class DefaultSeekBar extends AppCompatSeekBar {

    /**
     * 是否支持拖动进度
     */
    private boolean touch = false;

    public DefaultSeekBar(Context context, AttributeSet attrs) {
        this(context, attrs, 0);
    }

    public DefaultSeekBar(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }


    public void setTouch(boolean touch) {
        this.touch = touch;
    }

    @Override
    public boolean onTouchEvent(MotionEvent event) {
        if (touch) {
            return super.onTouchEvent(event);
        }
        return false;
    }

}
