package im.zego.ktv.custom;

import android.app.Activity;
import android.app.Dialog;
import android.view.Gravity;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;

import im.zego.ktv.R;


/**
 * 歌曲搜索
 */
public class KTVScoreShowDialog extends Dialog {


    private ImageView mIvScoreShow;
    private TextView mKtvTotalScore;

    public KTVScoreShowDialog(@NonNull Activity activity) {
        this(activity,  R.style.BaseBottomSheetDialog);
    }

    public KTVScoreShowDialog(@NonNull Activity activity, int themeResId) {
        super(activity, themeResId);
        init();
    }

    private void init() {
        setCancelable(false);

        //设置dialog位置
        Window window = getWindow();
        if (window != null) {
            window.getDecorView().setPadding(0, 0, 0, 0);
            WindowManager.LayoutParams layoutParams = window.getAttributes();
            layoutParams.width = WindowManager.LayoutParams.MATCH_PARENT;
            layoutParams.height = WindowManager.LayoutParams.MATCH_PARENT;
            layoutParams.horizontalMargin = 0;
            layoutParams.gravity = Gravity.BOTTOM;
            window.setAttributes(layoutParams);
        }

        setContentView(R.layout.ktv_dialog_score_show);
        mIvScoreShow = findViewById(R.id.iv_score_show);
        mKtvTotalScore = findViewById(R.id.ktv_total_score);
        ImageView mKtvScoreOk = findViewById(R.id.ktv_score_ok);
        mKtvScoreOk.setOnClickListener(v -> dismiss());
    }



    public void setScoreShow(int averageScore,int totalScore){
        mKtvTotalScore.setText(String.valueOf(totalScore));

        if(averageScore >= 90) {
            mIvScoreShow.setImageResource(R.mipmap.ktv_score_s);
        }else if(averageScore >= 80){
            mIvScoreShow.setImageResource(R.mipmap.ktv_score_a);
        }else if(averageScore >= 70){
            mIvScoreShow.setImageResource(R.mipmap.ktv_score_b);
        }else if(averageScore >= 60){
            mIvScoreShow.setImageResource(R.mipmap.ktv_score_c);
        }else {
            mIvScoreShow.setImageResource(R.mipmap.ktv_score_d);
        }

    }



}
