package im.zego.lyricview.model;

import com.google.gson.annotations.SerializedName;

import java.util.List;


public class ZGKTVLyric {
    // 逐行歌词
    @SerializedName("lrc_format")
    private String lrcFormat;

    // 逐字歌词

    private boolean hasKrcFormat = false;
    @SerializedName("krc_format_offset")
    private long krcFormatOffset;
    @SerializedName("lines")
    private List<LyricSingleLineModel> lines;

    public String getLrcFormat() {
        return lrcFormat;
    }

    public void setLrcFormat(String lrcFormat) {
        this.lrcFormat = lrcFormat;
    }

    public boolean isHasKrcFormat() {
        return hasKrcFormat;
    }

    public void setHasKrcFormat(boolean hasKrcFormat) {
        this.hasKrcFormat = hasKrcFormat;
    }

    public long getKrcFormatOffset() {
        return krcFormatOffset;
    }

    public void setKrcFormatOffset(long krcFormatOffset) {
        this.krcFormatOffset = krcFormatOffset;
    }

    public List<LyricSingleLineModel> getLines() {
        return lines;
    }

    /**
     * 单行歌词的结构体
     */
    public static class LyricSingleLineModel {
        // 这行的开始时间
        @SerializedName("begin_time")
        private long beginTime;

        // 这行的持续时间
        @SerializedName("duration")
        private long duration;

        // 整行歌词内容
        @SerializedName("content")
        private String content;

        // 该行歌词每个词组的结构体集合
        @SerializedName("words")
        private List<LyricWordsModel> words;

        public long getBeginTime() {
            return beginTime;
        }

        public long getDuration() {
            return duration;
        }

        public String getContent() {
            return content;
        }

        public List<LyricWordsModel> getWords() {
            return words;
        }
    }

    public static class LyricWordsModel {
        // 基于这行 beginTime 的时间偏移量
        @SerializedName("offset")
        private long offset;

        // 持续时间
        @SerializedName("duration")
        private long duration;

        // 词组
        @SerializedName("word")
        private String word;

        public long getOffset() {
            return offset;
        }

        public long getDuration() {
            return duration;
        }

        public String getWord() {
            return word;
        }
    }
}
