## 1 秀场直播目录说明
### 1.1 主要目录说明
秀场直播位于项目中的Liveshow模块内，主要目录如下:
main
├── AndroidManifest.xml
├── assets
├── java
│  └── im
│    └── zego
│      └── liveshow
│        ├── AuthConstants.java         （AppID 和 AppSign的配置）
│        ├── BackendApiConstants.java   （后台地址的配置）
│        ├── Constants.java             （状态常量）
│        ├── ErrorcodeConstants.java    （错误码）
│        ├── effects                     (美颜效果和音效效果的管理)
│        ├── liveroom                   （直播房间页面）
│        ├── manager                    （相关管理类，主要包括房间管理，用户管理，断网恢复处理）
│        ├── model                      （数据模型类）
│        ├── protocol                   （网络请求的封装）
│        ├── roomlist                   （房间列表页面）
│        ├── sdk                        （SDK的封装）
│        ├── utils                      （工具类集合，包括图片加载的工具类）
│        └── view                       （自定义View和弹窗）
└── res

### 1.2 详细目录文件说明


main
  ├── AndroidManifest.xml
  ├── assets
  ├── java
  │  └── im
  │    └── zego
  │      └── liveshow
  │        ├── AuthConstants.java                       （AppID 和 AppSign的配置）
  │        ├── BackendApiConstants.java                 （后台地址的配置）
  │        ├── Constants.java                           （状态常量）
  │        ├── ErrorcodeConstants.java                  （错误码）
  │        ├── effects                                   (美颜效果和音效效果的管理)
  │        │  ├── EffectsBeautyManager.java             （美颜管理类，各项美颜效果的默认参数都在这个设置）
  │        │  ├── SoundEffectsManager.java              （音效管理类，各种音效的设置和默认设置都在这里设置）
  │        │  └── adapter                               （美颜，音效弹窗UI用到的列表适配器）
  │        │    ├── BackgroundSoundAdapter.java
  │        │    ├── BaseSelectAdapter.java
  │        │    ├── EffectsBeautyAdapter.java
  │        │    ├── ReverbPresetAdapter.java
  │        │    └── VoiceChangeAdapter.java
  │        ├── liveroom                                 （直播房间页面）
  │        │  ├── LiveRoomActivity.java
  │        │  ├── LiveRoomActivity2.java                （直播房间页面）
  │        │  ├── LiveRoomView.java                     （单个房间展示的视图）
  │        │  ├── adapter                               （UI列表适配器）
  │        │  │  ├── AudienceListAdapter.java
  │        │  │  ├── LiveRoomAdapter.java
  │        │  │  └── OnlineAdapter.java
  │        │  ├── callbacks                             （回调接口）
  │        │  │  ├── IAnchorInfoCallback.java
  │        │  │  ├── IHeartBeatFailCallback.java
  │        │  │  ├── IRoomQualityInfoCallback.java
  │        │  │  ├── IStateSeqCallback.java
  │        │  │  └── IUserSeqCallback.java
  │        │  ├── utils
  │        │  │  ├── HeartBeatUtil.java                 （心跳工具类，保证用户在房间内活跃，不会被踢出房间）
  │        │  │  └── NetworkCallbackImpl.java           （网络状态的变更）
  │        │  └── view
  │        │    ├── CloseRoomView.java                  （直播已结束的视图）
  │        │    ├── HintCoverView.java
  │        │    ├── HostInfoView.java                   （房间上方信息视图）
  │        │    └── ResolutionView.java                 （分辨率选项视图）
  │        ├── manager                                  （相关管理类，主要包括房间管理，用户管理，断网恢复处理）
  │        │  ├── NetWorkConManager.java                （用户断网重连后数据恢复处理）
  │        │  ├── ResolutionManager.java                （分辨率的设置）
  │        │  ├── RoomManager.java                      （房间管理类，保存此房间的数据和状态）
  │        │  ├── UserManager.java                      （用户管理类，修改实现方法可以快速接入第三方的账号体系）
  │        │  └── callbacks
  │        │    ├── ICreateRoomFailTimeoutCallback.java
  │        │    ├── INetworkOperationCallback.java
  │        │    ├── IRoomConnectionCallback.java
  │        │    ├── IRoomDisconnectCallback.java
  │        │    ├── IRoomManagerCallback.java
  │        │    ├── ISDKRoomStateCallback.java
  │        │    ├── IStreamCallback.java
  │        │    └── ISwitchRoomStateCallback.java
  │        ├── model                                    （数据模型类）
  │        │  ├── AudioEffectInfo.java                  
  │        │  ├── BeautyInfo.java
  │        │  ├── HeartbeatRespInfo.java
  │        │  ├── NoInfo.java
  │        │  ├── OnlineInfo.java
  │        │  ├── OnstageListInfo.java
  │        │  ├── ReverbPresetInfo.java
  │        │  ├── RoomInfo.java
  │        │  ├── RoomListInfo.java
  │        │  ├── StatefulListInfo.java
  │        │  ├── UserInfo.java
  │        │  ├── VoiceChangeInfo.java
  │        │  └── rtc
  │        │    ├── NotifyApplyMicStateInfo.java
  │        │    ├── NotifyRefuseApplyMicInfo.java
  │        │    ├── NotifyUserListUpdateInfo.java
  │        │    └── NotifyUserStateUpdateInfo.java
  │        ├── protocol                                 （网络请求的封装）
  │        │  ├── APIBase.java                          （okhttp的封装类）
  │        │  ├── IApplyMicStateNotifyCallback.java
  │        │  ├── IAsyncPostCallback.java
  │        │  ├── ICommonResponseCallback.java
  │        │  ├── ICreateRoomCallback.java
  │        │  ├── IExecuteCallback.java
  │        │  ├── IGetConMicListCallback.java
  │        │  ├── IGetHostAudiencetCallback.java
  │        │  ├── IGetOnlineInfoCallback.java
  │        │  ├── IGetRoomListCallback.java
  │        │  ├── IGetStatefulListCallback.java
  │        │  ├── IHeartBeatCallback.java
  │        │  ├── ILoginRoomCallback.java
  │        │  ├── JsonBuilder.java                      （辅助生成json字符串）
  │        │  └── RoomAPI.java                          （秀场直播后台请求的封装）
  │        ├── roomlist                                 （房间列表页面）
  │        │  ├── RoomListActivity.java                 （房间列表页面）
  │        │  ├── adapter                               （列表适配器）
  │        │  │  ├── EmptyAndLoadMoreAdapterWrapper.java
  │        │  │  └── RoomListAdapter.java
  │        │  └── view
  │        │    ├── GridLayoutItemDecoration.java       （列表分割线）
  │        │    └── LoadMoreView.java                   （加载更多视图）
  │        ├── sdk                                      （SDK的封装）    
  │        │  ├── IZegoVideoSDKProxy.java               （SDK封装的接口）
  │        │  ├── ZegoDeviceService.java                （SDK设备相关接口的调用服务，如：摄像头，麦克风的打开和关闭，设置预览画面等）
  │        │  ├── ZegoExpressWrapper.java               （SDK封装的具体实现类）
  │        │  ├── ZegoRoomService.java                  （SDK房间相关接口的调用服务,如：房间的登录和退出）
  │        │  ├── ZegoSDKManager.java                   
  │        │  ├── ZegoStreamService.java                （SDK音视频流相关接口的调用服务，如:推流和拉流）
  │        │  ├── callbacks
  │        │  │  ├── IBroadcastMessageListener.java
  │        │  │  ├── ICustomCommandListener.java
  │        │  │  ├── IPublisherQualityUpdateCallback.java
  │        │  │  ├── IRTCCommonCallback.java
  │        │  │  ├── IRTCEventCallback.java
  │        │  │  ├── IRemoteDeviceStateListener.java
  │        │  │  ├── IRoomExtraInfoUpdateListener.java
  │        │  │  ├── IRoomLoginCallback.java
  │        │  │  ├── IRoomMessageCallback.java
  │        │  │  ├── IRoomStateCallback.java
  │        │  │  ├── IRoomUserListener.java
  │        │  │  ├── IStreamActiveCallback.java
  │        │  │  ├── IStreamCountListener.java
  │        │  │  └── IZegoRoomConnectionStateListener.java
  │        │  └── model
  │        │    ├── ZegoPlayStream.java                 （音视频拉流类）
  │        │    ├── ZegoPublishStream.java              （音视频推流类）
  │        │    ├── ZegoRoomUser.java
  │        │    └── ZegoStream.java                     （音视频流抽象类）
  │        ├── utils                                    （工具类集合，包括图片加载的工具类）
  │        │  ├── CheckDoubleClick.java
  │        │  ├── CopyAssetsFileUtil.java
  │        │  ├── DialogQueue.java
  │        │  ├── DialogQueueUtils.java
  │        │  ├── GlideCircleTransform.java
  │        │  ├── GlideLoader.java                      （图片加载工具类）
  │        │  ├── ListSortUtils.java
  │        │  ├── NetworkSpeedUtil.java                 （网络速度检测工具类）
  │        │  ├── PermissionHelper.java                 （权限工具类）
  │        │  ├── SharedPreferencesUtil.java
  │        │  └── ToastUtil.java
  │        └── view                                     （自定义View和弹窗）
  │          ├── BaseBottomSheetDialogFragment.java     （基础滑动弹窗）
  │          ├── BaseInquiryDialog.java                 （基础选择弹窗）
  │          ├── EffectsBeautyDialog.java               （美颜美型弹窗）
  │          ├── EffectsBeautyTypeView.java             （美型视图列表）
  │          ├── EffectsBeautyView.java                 （美颜视图列表）
  │          ├── LiveshowRealtimeLayout.java            （实时数据视图）
  │          ├── MicManagerDialog.java                  （麦位管理弹窗，房主点击麦上用户触发）
  │          ├── MoreSettingDialog.java                 （更多设置弹窗，房主点击更多设置触发）
  │          ├── MoreSettingView.java                   （更多设置的单个菜单项视图）
  │          ├── OnlineDialog.java                      （在线人数点击后的弹窗，点击在线人数触发）
  │          ├── ProcessView.java                       （表示加载中的视图）
  │          ├── RoomBottomLayerLayout.java             （房间下方用户菜单的视图）
  │          ├── SeekBarWithNumber.java                 （美颜效果使用的调节滑块视图）
  │          ├── SoundEffectsDialog.java                （音效修改弹窗）
  │          └── SoundEffectsSeekBar.java               （音效使用到的滑块视图）
  └── res



## 2 快速接入
### 2.1 开启美颜功能
美颜功能的开启需要设置License字符串,秀场直播使用的是本地鉴权，请联系 ZEGO 技术支持获取美颜 License 。

美颜功能的封装位于 EffectsLib 模块，该模块的im.zego.effects.sdkmanager.LicenseConstants 类的 EFFECTS_LICENSE 变量修改为获取的 License 字符串。

如下图说示:

![9](./imgs/9.png)

![10](./imgs/10.png)


### 2.2 使用自己的账号体系
#### 2.2.1 修改用户昵称

目前秀场直播的昵称是随机生成的，对应方法为 im.zego.liveshow.manager.UserManager 的 generateUserName()。

修改此方法和调用方，返回自己的昵称即可

该方法 如图所示:

![11](./imgs/11.png)

#### 2.2.2 修改用户头像

目前秀场直播的头像是随机生成的，对应方法为 im.zego.liveshow.manager.UserManager 的 getAvatar(String nickName)。

修改此方法和调用方，返回自己的头像即可。

该方法 如图所示:

![12](./imgs/12.png)

目前秀场直播的头像是使用本地图片加载，用户需要修改图片加载工具类 im.zego.liveshow.utils.GlideLoader 的displayCircleImageByAvatar(String avatar, ImageView imageView) 和 displayRoundImageByAvatar(String avatar, ImageView imageView) 方法，实现加载图片功能。


#### 2.2.3 修改用户id

登录房间的用户id(uid)是后台随机生成的，如果需要设置自己的id,可以在登录和创建房间前调用  im.zego.liveshow.manager.UserManager 的 setUid(long uid) ，设置一个不为0的整数，设置为0会使用后台随机生成的uid。

该方法 如图所示:

![13](./imgs/13.png)

## 3 实现流程

请参考 https://doc-zh.zego.im/article/11242







